<?php
/**
 * Clase Base DP para BaseCrLlamadasMovimientoDP
 *
 * @package    
 * @subpackage BaseCrLlamadasMovimientoDP
 * @author     Willy
 * @version    SVN:: BaseCrLlamadasMovimientoDP.class.php,v 1.1 2014-10-30 10:20:41 william.taype Exp $
 */
abstract class BaseCrLlamadasMovimientoDP extends CrLlamadasMovimientoBN
{
  /* Número de registros afectados */
  private $nRowsAffected;

  public function __construct($bSetDefault = true)
  {
    if( $bSetDefault instanceof CrLlamadasMovimientoBN )
    {
      $o_CrLlamadasMovimientoBN = $bSetDefault;
      if($o_CrLlamadasMovimientoBN->getIdMovimientoLlamada()) : $this->setIdMovimientoLlamada($o_CrLlamadasMovimientoBN->getIdMovimientoLlamada()); endif;
      if($o_CrLlamadasMovimientoBN->getIdCliente()) : $this->setIdCliente($o_CrLlamadasMovimientoBN->getIdCliente()); endif;
      if($o_CrLlamadasMovimientoBN->getIdTelefono()) : $this->setIdTelefono($o_CrLlamadasMovimientoBN->getIdTelefono()); endif;
      if($o_CrLlamadasMovimientoBN->getFecha()) : $this->setFecha($o_CrLlamadasMovimientoBN->getFecha()); endif;
    }
  }

  /* Obtiene el número de registros afectados */
  public function getRowsAffected()
  {
    return $this->nRowsAffected;
  }

  public function save()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IF(MAX(IdMovimientoLlamada),(MAX(IdMovimientoLlamada)+1), 1) AS Maximo FROM cr_llamadas_movimiento;";
      $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
      $result = mysql_query($sql, $oLink);
      $row = mysql_fetch_array($result);
      $this->setIdMovimientoLlamada($row[0]);

      if($this->getIdMovimientoLlamada()){
        $a_Fields = array();

        if($this->getIdMovimientoLlamada()) : $a_Fields['IdMovimientoLlamada'] = ($this->getIdMovimientoLlamada()); endif;
        if($this->getIdCliente()) : $a_Fields['IdCliente'] = ($this->getIdCliente()); endif;
        if($this->getIdTelefono()) : $a_Fields['IdTelefono'] = ($this->getIdTelefono()); endif;
        if($this->getFecha()) : $a_Fields['Fecha'] = ($this->getFecha()); endif;

        $sStringField = arrayClass::implode_keys(',', $a_Fields);
        $sStringValue = "'".implode("','", $a_Fields)."'";

        $sql = "INSERT INTO cr_llamadas_movimiento (".$sStringField.") VALUES (".$sStringValue.");";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function update()
  {
    try
    {
      if($this->getIdMovimientoLlamada())
      {
        $a_Fields = array();

        if($this->getIdMovimientoLlamada()) : $a_Fields['IdMovimientoLlamada'] = ($this->getIdMovimientoLlamada()); endif;
        if($this->getIdCliente()) : $a_Fields['IdCliente'] = ($this->getIdCliente()); endif;
        if($this->getIdTelefono()) : $a_Fields['IdTelefono'] = ($this->getIdTelefono()); endif;
        if($this->getFecha()) : $a_Fields['Fecha'] = ($this->getFecha()); endif;

        $sStringField = arrayClass::implode_key_value(',', $a_Fields);

        $con = Conexion::getConexion();
        $sql = "UPDATE cr_llamadas_movimiento SET ".$sStringField." WHERE 1 AND IdMovimientoLlamada='".$this->getIdMovimientoLlamada()."';";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  public function delete()
  {
    try
    {
      if($this->getIdMovimientoLlamada())
      {
        $a_Fields = array();

        $con = Conexion::getConexion();
        $sql = "DELETE FROM cr_llamadas_movimiento WHERE 1 AND IdMovimientoLlamada='".$this->getIdMovimientoLlamada()."';"; 
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
        if($result)
        {
          $this->nRowsAffected = (int) mysql_affected_rows($oLink);
        }
        else
        {
          throw new Exception( mysql_error($oLink) );
        }
      }
      else
      {
        throw new Exception( 'El id no esta registrado.');
      }
    }
    catch ( Exception $o_Error )
    {
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
    return true;
  }

  /* Búsqueda del registro por la llave primaria */
  public static function selectByPK($vIdMovimientoLlamada)
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT IdMovimientoLlamada, IdCliente, IdTelefono, Fecha FROM cr_llamadas_movimiento WHERE 1 AND IdMovimientoLlamada='".$vIdMovimientoLlamada."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      
      return $o_Propel?self::insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_CrLlamadasMovimientoDP = new CrLlamadasMovimientoDP();
    $o_CrLlamadasMovimientoDP->setIdMovimientoLlamada($o_propel->IdMovimientoLlamada);
    $o_CrLlamadasMovimientoDP->setIdCliente($o_propel->IdCliente);
    $o_CrLlamadasMovimientoDP->setIdTelefono($o_propel->IdTelefono);
    $o_CrLlamadasMovimientoDP->setFecha($o_propel->Fecha);
    return $o_CrLlamadasMovimientoDP;
  }
}